<template>
  <rui-form :errors="errors"
            model="user"
            :loading="loading"
            :submit-button-title="$t('js.user.invite_on_instance')"
            submit-button-icon="send-message"
            :cancellable="true"
            @cancel="$emit('cancel')"
            @submit.prevent="invite">
    <rui-field v-if="!email" :input-id="`email_${id}`" :label="$t('activerecord.attributes.user.email')">
      <input :id="`email_${id}`"
             v-model="inputs.email"
             type="email"
             name="email"
             required>
    </rui-field>
    <rui-icon-text v-else variant="info" icon="info">{{ $t('js.users.invite_email', { email: inputs.email }) }}</rui-icon-text>

    <rui-field :input-id="`username_${id}`" :label="$t('activerecord.attributes.user.username')">
      <input :id="`username_${id}`"
             v-model="inputs.username"
             type="text"
             name="username"
             required
             min="3">
    </rui-field>
  </rui-form>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiIconText from '@experiments-labs/rise_ui/src/components/IconText/IconText.vue'

import User from '../../../../classes/models/User'
import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaUserInvitationForm',
  emits: [
    'cancel',
    'invited',
  ],
  components: { RuiIconText, RuiField, RuiForm },
  props: {
    email: { required: false, type: String, default: null },
    showSuccessNotification: { required: false, type: Boolean, default: true },
  },
  data () {
    return {
      id: randomString(5),
      inputs: {
        email: '',
        username: '',
      },
      loading: false,
      errors: null,
    }
  },
  methods: {
    reset () {
      this.inputs = {
        email: this.$props.email || '',
        username: '',
      }
    },
    invite () {
      const payload = { email: this.inputs.email, username: this.inputs.username }

      this.loading = true
      this.errors = null
      User.sendInvitation(payload)
        .then((user) => {
          if (this.showSuccessNotification) Toaster.success(this.$t('js.user.successfully_invited', { name: user.username }))
          this.$emit('invited', user)
        })
        .catch(e => { this.errors = e })
        .then(() => { this.loading = false })
    },
  },
  created () {
    this.reset()
  },
  watch: {
    email (newValue) {
      this.inputs.email = newValue || ''
    },
  },
}
</script>
